﻿using DotStat.Common.Configuration.Dto;
using DotStat.Common.Localization;
using DotStat.Common.Logger;
using DotStat.Domain;
using Estat.Sri.MappingStore.Store.Model;
using Estat.Sri.MappingStoreRetrieval.Config;
using Estat.Sri.MappingStoreRetrieval.Factory;
using Estat.Sri.MappingStoreRetrieval.Helper;
using Estat.Sri.MappingStoreRetrieval.Manager;
using Org.Sdmxsource.Sdmx.Api.Constants;
using Org.Sdmxsource.Sdmx.Api.Manager.Retrieval;
using Org.Sdmxsource.Sdmx.Api.Model;
using Org.Sdmxsource.Sdmx.Api.Model.Mutable.Registry;
using Org.Sdmxsource.Sdmx.Api.Model.Objects;
using Org.Sdmxsource.Sdmx.Api.Model.Objects.DataStructure;
using Org.Sdmxsource.Sdmx.Api.Model.Objects.Registry;
using Org.Sdmxsource.Sdmx.Api.Model.Objects.Codelist;
using Org.Sdmxsource.Sdmx.Api.Model.Objects.MetadataStructure;
using Org.Sdmxsource.Sdmx.SdmxObjects.Model.Mutable.Registry;
using Org.Sdmxsource.Sdmx.SdmxObjects.Model.Objects.Base;
using Org.Sdmxsource.Sdmx.SdmxObjects.Model.Objects.Registry;
using Org.Sdmxsource.Sdmx.Util.Objects.Reference;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Globalization;
using System.Linq;
using System.Reflection;
using DotStat.Common.Configuration;
using DotStat.Common.Exceptions;
using Estat.Sri.Mapping.Api.Constant;
using Estat.Sri.Mapping.Api.Manager;
using Estat.Sri.Mapping.Api.Model;
using Estat.Sri.Mapping.MappingStore.Extension;
using Org.Sdmxsource.Sdmx.SdmxObjects.Model.Mutable.Base;
using Dataflow = DotStat.Domain.Dataflow;
using Attribute = DotStat.Domain.Attribute;
using DataSetColumnEntity = Estat.Sri.Mapping.Api.Model.DataSetColumnEntity;
using MappingSetEntity = Estat.Sri.Mapping.Api.Model.MappingSetEntity;
using DotStat.Domain.Cache;
using Estat.Sri.Mapping.Api.Engine;
using Estat.Sri.Mapping.MappingStore.Engine;
using Estat.Sri.MappingStoreRetrieval.Extensions;
using System.Security.Cryptography;


namespace DotStat.MappingStore
{
    /// <summary>
    /// This class is not thread safe and should be used in a Scoped|Transient context
    /// </summary>
    public class MappingStoreDataAccess : IMappingStoreDataAccess
    {
        private const string AvailabilityConstraintCountId = "obs_count";
        private const string AvailabilityConstraintCountType = "sdmx_metrics";

        private readonly Dictionary<string, DataspaceInternal> _dataSpaceDict;
        private readonly IEntityRetrieverManager _retrieverManager;
        private readonly IEntityPersistenceManager _persistManager;
        private readonly bool _applyEmptyDataDbConnectionStringInMsdb;
        private ICache _cache;

        private readonly IDatabaseProviderManager _databaseProviderManager;
        private const string MappingSetPrefix = "AUTO_MAP_SET_";
        private const string StructDbPrefix = "DotStatSuiteCoreStructDb";
        private const string DataDbPrefix = "DotStatSuiteCoreDataDb";
        private const string EntityDescription = $"automatically generated by the dotstatsuite-core-transfer service ({MappingSetVersion})";
        private const string MappingSetVersion = "v1"; //todo save in a separate field ?

        private const string NotSavedConnectionInfoToken = "NOT_SAVED";

        private const string CrossApplyColumnName = "SID";

        public MappingStoreDataAccess(BaseConfiguration configuration,
            IEntityPersistenceManager entityPersistenceManager,
            IEntityRetrieverManager entityRetrieverManager,
            IDatabaseProviderManager databaseProviderManager,
            ICache cache
        )
        {
            ConfigManager.Config.DataflowConfiguration.IgnoreProductionForStructure = true;
            ConfigManager.Config.DataflowConfiguration.IgnoreProductionForData = true;
            ConfigManager.Config.GeneralDatabaseSettings[GetMappingStoreDbProvider(configuration.SpacesInternal.FirstOrDefault())].CommandTimeout
                = configuration.SpacesInternal.Select(x => x.DatabaseCommandTimeoutInSec).Max();

            MappingStoreIoc.Register<RetrievalEngineContainerFactory>("MappingStoreRetrieversFactory");

            _persistManager = entityPersistenceManager;
            _retrieverManager = entityRetrieverManager;
            _databaseProviderManager = databaseProviderManager;

            _dataSpaceDict = configuration.SpacesInternal.ToDictionary(ds => ds.Id, ds => ds, StringComparer.InvariantCultureIgnoreCase);

            _applyEmptyDataDbConnectionStringInMsdb = configuration.ApplyEmptyDataDbConnectionStringInMSDB;

            _cache = cache;
        }

        public Dataflow GetDataflow(string dataSpaceId, string agencyId, string dataflowId, string version,
            bool throwErrorIfNotFound, ResolveCrossReferences resolveCrossReferences = ResolveCrossReferences.ResolveExcludeAgencies, bool useCache = true)
        {
            string cacheKey = null;

            if (useCache)
            {
                cacheKey = $"{dataSpaceId}-{agencyId}:{dataflowId}({version})-{resolveCrossReferences}";

                Log.Debug($"Fetching structure: {cacheKey}");

                if (_cache.TryGetValue<Dataflow>(cacheKey, out var df))
                    return df;

                Log.Debug($"Cache miss: {cacheKey}");
            }

            var sdmxObjects = GetStructures(dataSpaceId, agencyId, dataflowId, version, SdmxStructureEnumType.Dataflow);

            if (!sdmxObjects.Dataflows.Any())
            {
                if (throwErrorIfNotFound)
                    throw new DotStatException(string.Format(
                        LocalizationRepository.GetLocalisedResource(Localization.ResourceId
                            .DataflowNotFoundInDataspace),
                        agencyId, dataflowId, version, dataSpaceId));

                return null;
            }

            var dfInDb = SdmxParser.ParseDataFlowStructure(sdmxObjects, resolveCrossReferences);
            SetCurrentMsd(dataSpaceId, dfInDb.Dsd);

            if (useCache)
            {
                _cache.Set<Dataflow>(cacheKey, dfInDb);
            }

            return dfInDb;
        }


        public Dataflow GetDataflow(
            string dataSpaceId, 
            IDataflowObject dataflowObject, 
            IDataStructureObject dataStructureObject, 
            IMetadataStructureDefinitionObject metadataStructureObject,
            ResolveCrossReferences resolveCrossReferences = ResolveCrossReferences.ResolveExcludeAgencies, 
            bool useDataflowCache = true,
            bool useMsdCache = false
         )
        {
            if (dataflowObject is null)
            {
                throw new ArgumentException(nameof(dataflowObject));
            }

            string cacheKey = null;

            if (useDataflowCache)
            {
                cacheKey = $"{dataSpaceId}-{dataflowObject.AgencyId}:{dataflowObject.Id}({dataflowObject.Version})-{resolveCrossReferences}";

                if (_cache.TryGetValue<Dataflow>(cacheKey, out var df))
                    return df;
            }

            Dataflow dfInDb;

            if (resolveCrossReferences == ResolveCrossReferences.DoNotResolve)
            {
                var dsd = new Dsd(dataStructureObject);
                dsd.SetDimensions(dataStructureObject.DimensionList.Dimensions.Select((dim, index) => new Dimension(index, dim)));
                dsd.SetAttributes(dataStructureObject.Attributes.Select(attr => new Attribute(attr)));
                dfInDb = new Dataflow(dataflowObject, dsd);
            }
            else
            {
                var codelists = FetchCodelists(dataSpaceId, dataStructureObject);
                var contentConstraintObject = FetchDataflowConstrains(dataSpaceId, dataflowObject.AgencyId, dataflowObject.Id, dataflowObject.Version)
                    .FirstOrDefault(c => !c.IsDefiningActualDataPresent);
                
                dfInDb = SdmxParser.ParseStructure(dataflowObject, dataStructureObject, metadataStructureObject, codelists, contentConstraintObject);
            }
            
            if(metadataStructureObject is not null)
            {
                dfInDb.Dsd.Msd = new Msd(metadataStructureObject);
            }
            else
            {
                SetCurrentMsd(dataSpaceId, dfInDb.Dsd, useMsdCache);
            }

            if (useDataflowCache)
            {
                _cache.Set<Dataflow>(cacheKey, dfInDb);
            }

            return dfInDb;
        }

        public Dsd GetDsd(string dataSpaceId, string agencyId, string dsdId, string version,
            bool throwErrorIfNotFound, ResolveCrossReferences resolveCrossReferences = ResolveCrossReferences.ResolveExcludeAgencies, bool useCache = true)
        {
            string cacheKey = null;
            if (useCache)
            {
                cacheKey = $"{dataSpaceId}-{agencyId}:{dsdId}({version})-{resolveCrossReferences}";
                Log.Debug($"Fetching structure: {cacheKey}");

                if (_cache.TryGetValue<Dsd>(cacheKey, out var cachedDsd))
                    return cachedDsd;

                Log.Debug($"Cache miss: {cacheKey}");
            }

            var sdmxObjects = GetStructures(dataSpaceId, agencyId, dsdId, version, SdmxStructureEnumType.Dsd);

            if (!sdmxObjects.DataStructures.Any())
            {
                if (throwErrorIfNotFound)
                    throw new DotStatException(string.Format(
                        LocalizationRepository.GetLocalisedResource(Localization.ResourceId
                            .DsdNotFoundInDataspace),
                        agencyId, dsdId, version, dataSpaceId));

                return null;
            }

            var dsdInDb = SdmxParser.ParseDsdStructure(sdmxObjects, resolveCrossReferences);
            SetCurrentMsd(dataSpaceId, dsdInDb, useCache);

            if (useCache)
            {
                _cache.Set<Dsd>(cacheKey, dsdInDb);
            }

            return dsdInDb;
        }

        public Dsd GetDsd(string dataSpaceId, IDataStructureObject dataStructure, IMetadataStructureDefinitionObject metadataStructureObject, bool useDsdCache = true, bool useMsdCache = false)
        {
            string cacheKey = null;
            if (useDsdCache)
            {
                cacheKey = $"{dataSpaceId}-{dataStructure.AgencyId}:{dataStructure.Id}({dataStructure.Version})-{ResolveCrossReferences.ResolveExcludeAgencies}";

                if (_cache.TryGetValue<Dsd>(cacheKey, out var cachedDsd))
                    return cachedDsd;
            }

            if (dataStructure is null)
            {
                throw new DotStatException(string.Format(
                    LocalizationRepository.GetLocalisedResource(Localization.ResourceId
                        .DsdNotFoundInDataspace),
                    dataStructure.AgencyId, dataStructure.Id, dataStructure.Version, dataSpaceId));
            }

            var codelists1 = FetchCodelists(dataSpaceId, dataStructure);
            
            var dsd = SdmxParser.ParseStructure(dataStructure, metadataStructureObject, codelists1);

            if (metadataStructureObject is not null)
            {
                dsd.Msd = new Msd(metadataStructureObject);
            }
            else
            {
                SetCurrentMsd(dataSpaceId, dsd, useMsdCache);
            }

            if (useDsdCache)
            {
                _cache.Set<Dsd>(cacheKey, dsd);
            }

            return dsd;
        }


        public ISdmxObjects GetDsd(string dataSpaceId, string agencyId, string dsdId, string version)
        {
            var reference = new StructureReferenceImpl(agencyId, dsdId, version, SdmxStructureEnumType.Dsd);

            return GetMappingStoreSdmxObjectRetrievalManager(dataSpaceId)
                .GetSdmxObjects(reference, ResolveCrossReferences.ResolveExcludeAgencies);
        }

        private ISdmxObjects GetMsd(string dataSpaceId, string msdAnnotationTitle)
        {
            var reference = new StructureReferenceImpl(msdAnnotationTitle);

            return GetMappingStoreSdmxObjectRetrievalManager(dataSpaceId)
                .GetSdmxObjects(reference, ResolveCrossReferences.ResolveExcludeAgencies);
        }

        public ISet<IDataStructureObject> GetDataStructures(string dataSpace)
        {
            return GetRetrievalManager(dataSpace)
                .GetMaintainableObjects<IDataStructureObject>(new MaintainableRefObjectImpl(), false, false);
        }

        public ISet<IDataflowObject> GetDataflows(string dataSpace)
        {
            return GetRetrievalManager(dataSpace)
                .GetMaintainableObjects<IDataflowObject>(new MaintainableRefObjectImpl(), false, false);
        }

        public ISdmxObjectRetrievalManager GetRetrievalManager(string dataSpaceId)
        {
            return GetMappingStoreSdmxObjectRetrievalManager(dataSpaceId);
        }

        /// <summary>
        /// Delete actual content constraint
        /// </summary>
        /// <param name="dataSpaceId">The ID of the targeted dataSpace</param>
        /// <param name="agencyId">Reference to which content constraints should be deleted</param>
        /// <param name="id">Reference to which content constraints should be deleted</param>
        /// <param name="version">Reference to which content constraints should be deleted</param>
        /// <param name="targetTable">The code of the table version (A or B) the constraint belongs to</param>
        /// <param name="targetVersion">defines which (actual) content constraint should be deleted: Live or PIT version?</param>
        public void DeleteActualContentConstraint(string dataSpaceId, string agencyId, string id, string version,
            char targetTable, TargetVersion targetVersion)
        {
            var artefactImportStatuses = new List<ArtefactImportStatus>();
            var manager =
                new Estat.Sri.MappingStore.Store.Manager.MappingStoreManager(
                    GetMappingStoreConnectionStringSettings(dataSpaceId), artefactImportStatuses);
            var constraints = FetchDataflowConstrains(dataSpaceId, agencyId, id, version);

            foreach (var c in constraints.Where(x => x.IsDefiningActualDataPresent))
            {
                var annotation = c.Annotations.FirstOrDefault(x => "ReleaseVersion".Equals(x.Type, StringComparison.InvariantCultureIgnoreCase));

                if (annotation != null)
                {
                    var title = annotation.Title;

                    if (!string.IsNullOrEmpty(title) && !title.Equals(targetTable.ToString(),
                        StringComparison.InvariantCultureIgnoreCase))
                    {
                        // Reset Live CC endDate
                        if (targetVersion == TargetVersion.PointInTime && c is ContentConstraintObjectCore liveAcc)
                        {
                            liveAcc.EndDate = null;
                            manager.SaveStructure(liveAcc);
                        }

                        continue;
                    }
                }

                manager.DeleteStructure(c);
            }
        }

        /// <summary>
        /// Delete all the actual content constraints of a dataflow
        /// </summary>
        /// <param name="dataSpaceId">The ID of the targeted dataSpace</param>
        /// <param name="dataflow">The dataflow which the content constraints should be deleted</param>
        public void DeleteAllActualContentConstraints(string dataSpaceId, Dataflow dataflow)
        {
            var artefactImportStatuses = new List<ArtefactImportStatus>();
            var manager =
                new Estat.Sri.MappingStore.Store.Manager.MappingStoreManager(
                    GetMappingStoreConnectionStringSettings(dataSpaceId), artefactImportStatuses);

            var constraints = FetchDataflowConstrains(dataSpaceId, dataflow.AgencyId, dataflow.Base.Id, dataflow.Version.ToString());

            foreach (var c in constraints.Where(x => x.IsDefiningActualDataPresent))
            {
                manager.DeleteStructure(c);
            }
        }

        /// <summary>
        /// Creates/updates ACC related to a dataflow. 
        /// </summary>
        /// <param name="dataSpaceId">The dataspace ID in which the ACC should be created/updated</param>
        /// <param name="dataflow">The dataflow the content constraint is related with</param>
        /// <param name="cubeRegion">Collection of key/values used to generated the cube region of the content constraint</param>
        /// <param name="includedCubeRegion">Flag indicating whether the provided <paramref name="cubeRegion"/> is an included or excluded one. Please not that currenty only included is supported.</param>
        /// <param name="targetTable">Table targeted</param>
        /// <param name="targetVersion">Version targeted</param>
        /// <param name="liveAccStartDate"></param>
        /// <param name="obsCount">(Optional) Observation count to be added as annotation to the content constraint</param>
        /// <returns></returns>
        public void SaveContentConstraint(string dataSpaceId, Dataflow dataflow, IList<IKeyValuesMutable> cubeRegion,
            bool? includedCubeRegion, char targetTable, TargetVersion targetVersion, DateTime liveAccStartDate, long? obsCount = null)
        {
            var manager = new Estat.Sri.MappingStore.Store.Manager.MappingStoreManager(
                GetMappingStoreConnectionStringSettings(dataSpaceId), new List<ArtefactImportStatus>());

            var contentConstraint = BuildContentConstraintMutableCore(dataflow,targetTable,targetVersion, liveAccStartDate);

            // Add observation count annotation
            if (obsCount.HasValue)
            {
                contentConstraint.AddAnnotation(new AnnotationMutableCore()
                {
                    Id = AvailabilityConstraintCountId,
                    Title = obsCount.Value.ToString(CultureInfo.InvariantCulture),
                    Type = AvailabilityConstraintCountType
                });
            }

            switch (includedCubeRegion)
            {
                // Add included cube region
                case true when cubeRegion != null:
                {
                    contentConstraint.IncludedCubeRegion = new CubeRegionMutableCore();

                    foreach (var kv in cubeRegion)
                        contentConstraint.IncludedCubeRegion.AddKeyValue(kv);
                    break;
                }
                case false when cubeRegion != null:
                    throw new NotImplementedException();
            }

            // Save actual content constraint to db
            DeleteActualContentConstraint(dataSpaceId, dataflow.AgencyId, dataflow.Base.Id, dataflow.Base.Version, targetTable, targetVersion);
            manager.SaveStructure(contentConstraint.ImmutableInstance);

            if (targetVersion != TargetVersion.PointInTime) 
                return;
            
            // Update validTo property of live ACC (if exists) with PIT release date
            var liveVersion = targetTable == 'A' ? 'B' : 'A';
            var allConstrains = FetchDataflowConstrains(dataSpaceId, dataflow.AgencyId, dataflow.Code, dataflow.Version.ToString());
            var liveAcc = allConstrains.FirstOrDefault(c=>c.IsDefiningActualDataPresent && c.Id.Equals($"CR_{liveVersion}_{dataflow.Code}")) as ContentConstraintObjectCore;

            if (liveAcc == null) 
                return;

            liveAcc.EndDate = dataflow.Dsd.PITReleaseDate.HasValue
                ? new SdmxDateCore(
                    dataflow.Dsd.PITReleaseDate.Value.AddSeconds(-1),
                    TimeFormatEnumType.DateTime
                )
                : null;

            DeleteActualContentConstraint(dataSpaceId, dataflow.AgencyId, dataflow.Base.Id, dataflow.Base.Version, liveVersion, TargetVersion.PointInTime);
            manager.SaveStructure(liveAcc);
        }

        /// <summary>
        /// Creates a new actual ContentConstraintMutableCore instance and initializes it with default values (id, agency id, version, validFrom, validTo, release version annotation)
        /// </summary>
        /// <param name="dataflow">The dataflow the content constraint is related with</param>
        /// <param name="targetTable">Table targeted</param>
        /// <param name="targetVersion">Version targeted</param>
        /// <param name="liveAccStartDate"></param>
        /// <returns></returns>
        private ContentConstraintMutableCore BuildContentConstraintMutableCore(Dataflow dataflow, char targetTable, TargetVersion targetVersion, DateTime? liveAccStartDate = null)
        {
            var contentConstraint = new ContentConstraintMutableCore
            {
                Id = $@"CR_{targetTable}_{dataflow.Code}",
                AgencyId = dataflow.AgencyId,
                Version = dataflow.Base.Version,
                ExternalReference = TertiaryBool.GetFromEnum(TertiaryBoolEnumType.False),
                FinalStructure = TertiaryBool.GetFromEnum(TertiaryBoolEnumType.False),
                IsDefiningActualDataPresent = true
            };

            contentConstraint.AddName("en", $"Availability ({targetTable}) for {dataflow.Code}");

            if (targetVersion == TargetVersion.PointInTime)
            {
                // Set start date if constraint for PIT release
                contentConstraint.StartDate =
                    dataflow.Dsd.PITReleaseDate ?? System.Data.SqlTypes.SqlDateTime.MaxValue.Value;
            }
            else
            {
                if (liveAccStartDate.HasValue)
                {
                    contentConstraint.StartDate = liveAccStartDate;
                }
                
                if (dataflow.Dsd.PITReleaseDate.HasValue)
                {
                    // Set end date if constraint is for live release and there is PIT release date
                    contentConstraint.EndDate = dataflow.Dsd.PITReleaseDate.Value.AddSeconds(-1);
                }
            }

            contentConstraint.AddAnnotation(targetTable.ToString(), "ReleaseVersion", null);
            contentConstraint.ConstraintAttachment = new ContentConstraintAttachmentMutableCore();
            contentConstraint.ConstraintAttachment.StructureReference.Add(new StructureReferenceImpl
            {
                AgencyId = dataflow.Base.AgencyId,
                MaintainableId = dataflow.Base.Id,
                Version = dataflow.Base.Version,
                MaintainableStructureEnumType = SdmxStructureType.GetFromEnum(SdmxStructureEnumType.Dataflow),
                TargetStructureType = SdmxStructureType.GetFromEnum(SdmxStructureEnumType.Dataflow)
            });

            return contentConstraint;
        }

        /// <summary>
        /// Creates a new ContentConstraintObjectCore instance and copies included cube region and observation count annotation from original instance
        /// </summary>
        /// <param name="originalInstance">Original instance used to obtain included code region and observation count annotation</param>
        /// <param name="dataflow">The dataflow the content constraint is related with</param>
        /// <param name="targetTable">Table targeted</param>
        /// <param name="targetVersion">Version targeted</param>
        /// <returns>ContentConstraintObjectCore</returns>
        private ContentConstraintObjectCore CopyContentConstraintObjectCore(ContentConstraintObjectCore originalInstance, Dataflow dataflow, char targetTable, TargetVersion targetVersion)
        {
            var newMutableInstance = BuildContentConstraintMutableCore(dataflow, targetTable, targetVersion);

            // Copy included cube region
            newMutableInstance.IncludedCubeRegion = new CubeRegionMutableCore(originalInstance.IncludedCubeRegion);

            // Copy observation count annotation
            var obsCountAnnotation = originalInstance.Annotations.FirstOrDefault(c =>
                c.Id == AvailabilityConstraintCountId && c.Type == AvailabilityConstraintCountType);

            if (obsCountAnnotation != null)
            {
                newMutableInstance.AddAnnotation(new AnnotationMutableCore()
                {
                    Id = AvailabilityConstraintCountId,
                    Title = obsCountAnnotation.Title,
                    Type = AvailabilityConstraintCountType
                });
            }

            return newMutableInstance.ImmutableInstance as ContentConstraintObjectCore;
        }

        /// <summary>
        /// if there is an actual PIT version, live data cannot be changed ( TargetVersion.PointInTime will be enforced)
        /// </summary>
        ///
        /// <summary>
        /// Updates a ValidFrom and ValidTo properties of actual contents related to a dataflow. Creates ACC for PIT release version in case it is missing.
        /// </summary>
        /// <param name="dataSpaceId">The dataspace ID in which the update of ACCs should be done </param>
        /// <param name="dataflow">The dataflow the content constraint is related with</param>
        /// <param name="targetTable">Table targeted</param>
        /// <param name="targetVersion">Version targeted</param>
        /// <returns></returns>
        public void UpdateValidityOfContentConstraints(string dataSpaceId, Dataflow dataflow, char targetTable, TargetVersion targetVersion)
        {
            var liveVersion = targetVersion == TargetVersion.Live ? targetTable : targetTable == 'A' ? 'B' : 'A';
            var pitVersion = liveVersion == 'A' ? 'B' : 'A';

            var allConstrains = FetchDataflowConstrains(dataSpaceId, dataflow.AgencyId, dataflow.Code, dataflow.Version.ToString());
            var liveAcc = allConstrains.FirstOrDefault(c => c.IsDefiningActualDataPresent && c.Id.Equals($"CR_{liveVersion}_{dataflow.Code}")) as ContentConstraintObjectCore;
            var pitAcc = allConstrains.FirstOrDefault(c => c.IsDefiningActualDataPresent && c.Id.Equals($"CR_{pitVersion}_{dataflow.Code}")) as ContentConstraintObjectCore;

            if (targetVersion == TargetVersion.PointInTime && pitAcc == null && liveAcc != null)
            {
                pitAcc = CopyContentConstraintObjectCore(liveAcc, dataflow, targetTable, targetVersion);
            }

            var manager = new Estat.Sri.MappingStore.Store.Manager.MappingStoreManager(GetMappingStoreConnectionStringSettings(dataSpaceId), new List<ArtefactImportStatus>());

            if (liveAcc != null)
            {
                liveAcc.StartDate = null;
                liveAcc.EndDate = dataflow.Dsd.PITReleaseDate.HasValue
                    ? new SdmxDateCore(
                        dataflow.Dsd.PITReleaseDate.Value.AddSeconds(-1),
                        TimeFormatEnumType.DateTime
                    )
                    : null;

                manager.SaveStructure(liveAcc);
            }

            if (pitAcc != null)
            {
                pitAcc.StartDate =
                    new SdmxDateCore(dataflow.Dsd.PITReleaseDate ?? System.Data.SqlTypes.SqlDateTime.MaxValue.Value,
                        TimeFormatEnumType.DateTime);
                pitAcc.EndDate = null;

                manager.SaveStructure(pitAcc);
            }
        }

        /// <summary>
        /// Check if Dataflow has a MappingSet
        /// </summary>
        /// <param name="dataSpaceId">The dataSpace ID</param>
        /// <param name="dataFlow">Dataflow</param>
        /// <returns>true if Dataflow has a MappingSet</returns> 
        public (bool,bool) HasMappingSet(string dataSpaceId, Dataflow dataFlow)
        {
            var dataSpace = GetDataSpace(dataSpaceId);
            var storeId = GetMappingStoreDbConnectionName(dataSpace);
            var mappingSets = GetMappingSetsOfDataflow(storeId, dataFlow).ToList();

            var isAnyMappingSet = mappingSets.Any();
            var isAnyUserCreatedMappingSet = isAnyMappingSet && mappingSets.Any(d =>
                !d.Name.StartsWith($"{MappingSetPrefix}{dataFlow.FullId}", StringComparison.InvariantCultureIgnoreCase));

            return (isAnyMappingSet, isAnyUserCreatedMappingSet);
        }

        public bool DeleteDataSetsAndMappingSets(string dataSpaceId, Dataflow dataFlow, bool deleteMsdObjectsOnly)
        {
            var connection = GetOrCreateDataDbConnection(dataSpaceId);
            
            if (connection == null)
                return false;

            //Delete all mapping sets of dataflow, including the ones not created by the transfer-service
            var datasetIdsToDelete = DeleteAllDataflowMappingSets(connection.StoreId, dataFlow, deleteMsdObjectsOnly);

            if (datasetIdsToDelete.Any())
            {
                DeleteDatasets(connection.StoreId, datasetIdsToDelete);
                return true;
            }

            return false;
        }

        public bool CreateOrUpdateMappingSet(
            string dataSpaceId,
            Dataflow dataFlow,
            char targetVersion,
            DateTime? validFrom,
            DateTime? validTo,
            MappingSetParams @params
        )
        {
            var connection = GetOrCreateDataDbConnection(dataSpaceId, true);

            if (connection == null)
                return false;

            var datasetName = GetDatasetName(dataFlow, targetVersion, @params.IsMetadata);
            var check4MappingSet = false;

            //Create dataSet if it does not exist yet
            var dataSet = GetDataSet(connection.StoreId, datasetName);
            List<DataSetColumnEntity> datasetColumns = null;

            if (dataSet != null)
            {
                check4MappingSet = true;

                //The DataSet already exists, Update it
                //No need to update the DataSet DataSetColumnEntitities, since the sdmx structure is the same
                if (!UpdateDataSet(dataSet, @params))
                    return false;//could not update the DataSet
            }
            else
            {
                //The DataSet does not exist, Create it
                (dataSet,datasetColumns) = SaveDataSet(
                    connection, 
                    dataFlow.Dsd, 
                    datasetName,
                    @params
                );
                //The DataSet could not be created
                if (dataSet == null)
                    return false;
            }

            var mappingSet = check4MappingSet
                ? GetMappingSet(dataSet)
                : null;

            //If the mappingset already exists, update it
            //No need to update the ComponentMappingEntities, since the sdmx structure is the same
            if (mappingSet != null)
                return UpdateMappingSet(dataFlow, mappingSet, dataSet, validFrom, validTo, @params.IsMetadata);

            mappingSet = SaveMappingSet(dataSet, datasetColumns, dataFlow, validFrom, validTo, @params.IsMetadata);
            
            return mappingSet != null && SaveMappings(
                    connection.StoreId, 
                    mappingSet.EntityId, 
                    dataSet.EntityId,
                    dataFlow.Dsd, 
                    datasetColumns,
                    @params.IsMetadata
                );
        }

        public HashSet<string> GetMigratedMappingSets(string dataSpaceId)
        {
            var dataSpace = GetDataSpace(dataSpaceId);
            var storeId = GetMappingStoreDbConnectionName(dataSpace);
            var entityQuery = new EntityQuery { EntityType = EntityType.MappingSet };
            var dataSetEntities = _retrieverManager.GetEntities<MappingSetEntity>(storeId, entityQuery, Detail.Full);

            return new HashSet<string>(dataSetEntities.Where(IsMigrated).Select(d => d.Name));
        }

        private bool IsMigrated(MappingSetEntity ms)
        {
            return ms.Description != null &&
                   ms.Description.EndsWith(EntityDescription, StringComparison.InvariantCultureIgnoreCase);
        }

        public bool IsMigrated(Dataflow dataflow, HashSet<string> migratedMappingSets)
        {
            return GetAllMappingNames(dataflow).All(migratedMappingSets.Contains);
        }

        private IEnumerable<string> GetAllMappingNames(Dataflow df)
        {
            yield return MappingSetPrefix + GetDatasetName(df, 'A', false);
            yield return MappingSetPrefix + GetDatasetName(df, 'B', false);

            if (df.Dsd.Msd != null)
            {
                yield return MappingSetPrefix + GetDatasetName(df, 'A', true);
                yield return MappingSetPrefix + GetDatasetName(df, 'B', true);
            }
        }

        #region protected methods

        protected void SetCurrentMsd(string dataSpaceId, Dsd dsd, bool useCache = false)
        {
            if (!dsd.Base.Annotations.Any())
            {
                return;
            }

            var msdAnnotation = dsd.Base.Annotations.FirstOrDefault(x => "Metadata".Equals(x.Type, StringComparison.OrdinalIgnoreCase));

            if (msdAnnotation == null || string.IsNullOrEmpty(msdAnnotation.Title))
            {
                return;
            }

            dsd.Msd = GetMsd(dataSpaceId, msdAnnotation.Title, dsd, useCache);
        }

        private Msd GetMsd(string dataSpaceId, string msdFullId, Dsd dsd, bool useCache)
        {
            Msd msd = null;
            string cacheKey = null;

            if (useCache)
            {
                cacheKey = $"{dataSpaceId}-{msdFullId}";

                if (_cache.TryGetValue<Msd>(cacheKey, out msd))
                    return msd;
            }

            var baseMsdStructure = GetMsd(dataSpaceId, msdFullId)
                .MetadataStructures?
                .FirstOrDefault();

            if (baseMsdStructure == null)
                throw new DotStatException(string.Format(
                    LocalizationRepository.GetLocalisedResource(Localization.ResourceId.MSDNotFoundInStrucDB),
                    dsd.FullId, msdFullId, dataSpaceId)
                );

            msd = new Msd(baseMsdStructure);

            if (useCache)
            {
                _cache.Set<Msd>(cacheKey, msd);
            }

            return msd;
        }

        protected ISdmxObjects GetStructures(string dataSpaceId, string agencyId, string dataflowId, string version, SdmxStructureEnumType structureType)
        {
            var reference = new StructureReferenceImpl(agencyId, dataflowId, version, structureType);

            var ret = GetMappingStoreSdmxObjectRetrievalManager(dataSpaceId)
                .GetSdmxObjects(reference, ResolveCrossReferences.ResolveExcludeAgencies);

            if (!ret.HasContentConstraintBeans)
                foreach (var contentConstraint in FetchDataflowConstrains(dataSpaceId, agencyId, dataflowId, version))
                    ret.AddContentConstraintObject(contentConstraint);

            return ret;
        }

        #endregion

        #region private methods
        
        public static string GetDescription<T>(bool isMetadata) where T:IEntity
        {
            var type = typeof(T).Name switch
            {
                nameof(MappingSetEntity) => "mappingSet",
                nameof(DatasetEntity) => "dataSet",
                nameof(DataSetColumnEntity) => "dataSetColumn",
                _ => ""
            };

            return $"{(isMetadata ? "Metadata" : "Data")} {type} {EntityDescription}";
        }

        private string GetDatasetName(Dataflow df, char targetVersion, bool isMetadata)
        {
            return $"{df.FullId}_{targetVersion}" + (isMetadata ? "_META" : "");
        }

        private MappingStoreSdmxObjectRetrievalManager GetMappingStoreSdmxObjectRetrievalManager(string dataSpaceId)
        {
            var connectionStringSettings = GetMappingStoreConnectionStringSettings(dataSpaceId);
            return new MappingStoreSdmxObjectRetrievalManager(connectionStringSettings);
        }

        private IList<IContentConstraintObject> FetchDataflowConstrains(string dataSpaceId, string agencyId,
            string dataflowId, string version)
        {
            var reference = new StructureReferenceImpl(agencyId, dataflowId, version, SdmxStructureEnumType.Dataflow);
            var retrievalEngineContainer =
                new RetrievalEngineContainer(new Database(GetMappingStoreConnectionStringSettings(dataSpaceId)));
            var engine = retrievalEngineContainer.ContentConstraintRetrievalEngine;
            var constraints = engine.RetrieveFromReferenced(reference, ComplexStructureQueryDetailEnumType.Full);

            return constraints
                .Select(x => x.ImmutableInstance)
                .ToArray();
        }
        
        private IList<ICodelistObject> FetchCodelists(string dataSpaceId, IDataStructureObject dataStructure)
        {
            var codelists = new List<ICodelistObject>();
            var retrievalEngineContainer = new RetrievalEngineContainer(new Database(GetMappingStoreConnectionStringSettings(dataSpaceId)));
            var engine = retrievalEngineContainer.CodeListRetrievalEngine;

            if (dataStructure.DimensionList != null)
            {
                foreach (var dim in dataStructure.DimensionList.Dimensions.Where(d => d.HasCodedRepresentation()))
                {
                    var codelistMutableObjects = engine.Retrieve(dim.Representation.Representation.MaintainableReference.CreateComplexStructureReferenceObject(SdmxStructureEnumType.CodeList, false),
                        ComplexStructureQueryDetailEnumType.Full);
                    codelists.AddRange(codelistMutableObjects.Select(x => x.ImmutableInstance).ToArray());
                }
            }

            if (dataStructure.AttributeList != null)
            {
                foreach (var attr in dataStructure.AttributeList.Attributes.Where(d => d.HasCodedRepresentation()))
                {
                    var codelistMutableObjects = engine.Retrieve(attr.Representation.Representation.MaintainableReference.CreateComplexStructureReferenceObject(SdmxStructureEnumType.CodeList, false),
                        ComplexStructureQueryDetailEnumType.Full);
                    codelists.AddRange(codelistMutableObjects.Select(x => x.ImmutableInstance).ToArray());
                }
            }

            return codelists;
        }

        private DataspaceInternal GetDataSpace(string dataSpaceId)
        {
            if (!_dataSpaceDict.TryGetValue(dataSpaceId, out var dataSpace))
                throw new DotStatException(string.Format(
                    LocalizationRepository.GetLocalisedResource(Localization.ResourceId.DataSpaceNotFound),
                    dataSpaceId)
                );

            return dataSpace;
        }

        #region MappingStoreDBConnection

        private string GetMappingStoreDbConnectionName(DataspaceInternal dataSpace)
        {
            return $"{StructDbPrefix}_{dataSpace.Id}";
        }

        private string GetMappingStoreDbProvider(DataspaceInternal dataSpace) {
            DbType dbType = DbTypeHelper.GetDbType(dataSpace?.DbType, true);
            return dbType switch {
                DbType.SqlServer => MappingStoreDefaultConstants.SqlServerProvider,
                DbType.MariaDb => MappingStoreDefaultConstants.MySqlConnectorProvider,
                _ => MappingStoreDefaultConstants.SqlServerProvider
            };
        }

        private ConnectionStringSettings GetMappingStoreConnectionStringSettings(string dataSpaceId)
        {
            var dataSpace = GetDataSpace(dataSpaceId);
            var storeId = GetMappingStoreDbConnectionName(dataSpace);
            var provider = GetMappingStoreDbProvider(dataSpace);
            return new ConnectionStringSettings(storeId, dataSpace.DotStatSuiteCoreStructDbConnectionString, provider);
        }

        #endregion MappingStoreDBConnection

        #region DataDbConnection

        private string GetDataDbConnectionName(DataspaceInternal dataSpace)
        {
            return $"{DataDbPrefix}_{dataSpace.Id}";
        }

        private ConnectionStringSettings GetDataDbConnectionStringSettings(DataspaceInternal dataSpace)
        {
            var storeId = GetDataDbConnectionName(dataSpace);
            // Depending on value of the config parameter return "empty" or real connection string setting 
            return _applyEmptyDataDbConnectionStringInMsdb
                ? GetEmptyConnectionStringSetting(storeId, GetMappingStoreDbProvider(dataSpace))
                : new ConnectionStringSettings(storeId, dataSpace.DotStatSuiteCoreDataDbConnectionString, GetMappingStoreDbProvider(dataSpace));               
        }

        private ConnectionStringSettings GetEmptyConnectionStringSetting(string storeId, string provider) =>
            new ConnectionStringSettings(storeId,
                $"Server={NotSavedConnectionInfoToken};Database={NotSavedConnectionInfoToken};User={NotSavedConnectionInfoToken};Password={NotSavedConnectionInfoToken}",
                provider);

        private bool IsEmptyConnectionStringSetting(string dbName) => dbName == NotSavedConnectionInfoToken;

        private IConnectionEntity GetDataDbConnection(string storeId, string name)
        {
            var entityQuery = new EntityQuery {EntityType = EntityType.DdbConnectionSettings};
            //entityQuery.AddAdditionalCriteria(nameof(ConnectionEntity.Name), new Criteria<string>(OperatorType.Exact, name));

            var connectionEntities =
                _retrieverManager.GetEntities<IConnectionEntity>(storeId, entityQuery, Detail.Full);
            return connectionEntities.FirstOrDefault(c => c.Name == name);
        }

        private IConnectionEntity GetOrCreateDataDbConnection(string dataSpaceId, bool createIfMissing = false)
        {
            var dataSpace = GetDataSpace(dataSpaceId);
            var storeId = GetMappingStoreDbConnectionName(dataSpace);
            var name = GetDataDbConnectionName(dataSpace);

            //check if already exists
            var dataDbConnection = GetDataDbConnection(storeId, name);

            if (!createIfMissing)
            {
                return dataDbConnection;
            }

            // If dataDbConnection exists and is set according to actual connection string configuration parameter
            if (dataDbConnection != null && !(_applyEmptyDataDbConnectionStringInMsdb ^
                                              IsEmptyConnectionStringSetting(dataDbConnection.DbName)))
            {
                return dataDbConnection;
            }

            // Create new Connection String pointing to a Dissemination database
            var ddbConnectionString = GetDataDbConnectionStringSettings(dataSpace);

            var dbPluginEngine = _databaseProviderManager.GetEngineByProvider(ddbConnectionString.ProviderName);
            var connectionEntity = dbPluginEngine.SettingsBuilder.CreateConnectionEntity(ddbConnectionString);
            connectionEntity.StoreId = storeId;

            // Save new or update existing data db connection
            try
            {
                // Save a new db connection entry if it did not exist earlier
                if (dataDbConnection == null)
                {
                    return _persistManager.Add(connectionEntity);
                }

                // Update connection info entry if existed earlier but with different applyEmptyDataDbConnectionStringInMSDB config value
                connectionEntity.PatchRequest.Clear();
                connectionEntity.PatchRequest.Add(new PatchDocument("replace", "Server",
                    connectionEntity.Settings["Server"].Value));
                connectionEntity.PatchRequest.Add(new PatchDocument("replace", "DbName",
                    connectionEntity.Settings["Database"].Value));
                connectionEntity.PatchRequest.Add(new PatchDocument("replace", "DbUser",
                    connectionEntity.Settings["User ID"].Value));
                connectionEntity.PatchRequest.Add(new PatchDocument("replace", "Password",
                    connectionEntity.Settings["Password"].Value));
                connectionEntity.PatchRequest.Add(new PatchDocument("replace", "AdoConnString",
                    ddbConnectionString.ConnectionString));

                connectionEntity.EntityId = dataDbConnection.EntityId;

                _persistManager.Update(connectionEntity);

                return connectionEntity;
            }
            catch (System.Exception e)
            {
                Log.Error(new DotStatException(string.Format(
                    LocalizationRepository.GetLocalisedResource(Localization.ResourceId.ErrorTryingToCreateConnection),
                    name, dataSpace), e));
            }

            return null;
        }

        #endregion

        #region DataSet

        private IEntityRetrieverEngine<DatasetEntity> _engine;

        private IEntityRetrieverEngine<DatasetEntity> GetDatasetEngine(string storeId)
        {
            if (_engine == null)
            {
                _engine = _retrieverManager.GetRetrieverEngine<DatasetEntity>(storeId);

                if (_engine is DefaultsEntityRetrieverEngine<DatasetEntity>)
                {
                    var decoratedEngineInfo = _engine.GetType().GetField("_decoratedEngine", BindingFlags.NonPublic | BindingFlags.Instance);
                    var decoratedEngine = decoratedEngineInfo.GetValue(_engine);

                    var dictFieldInfo = decoratedEngine.GetType().GetField("_integerAdditionalProperties", BindingFlags.NonPublic | BindingFlags.Instance);
                    var dict = dictFieldInfo.GetValue(decoratedEngine);

                    var additionalPropertiesInfo = dict.GetType().GetProperty("Item");
                    additionalPropertiesInfo.SetValue(dict, "NAME", new[] { nameof(DatasetEntity.Name) });
                }
            }

            return _engine;
        }

        private DatasetEntity GetDataSet(string storeId, string datasetName)
        {
            // hack, patch criteria dict, todo: change maapi.net to add additional criteria there
            var engine = this.GetDatasetEngine(storeId);

            var entityQuery = new EntityQuery
            {
                EntityType = EntityType.DataSet
            };

            entityQuery.AddAdditionalCriteria(nameof(DatasetEntity.Name), new Criteria<string>(OperatorType.Exact, datasetName));

            return engine
                .GetEntities(entityQuery, Detail.Full)
                .FirstOrDefault();
        }

        private DatasetPropertyEntity GetDatasetProperty(MappingSetParams @params, DatasetEntity dataset = null)
        {
            var datasetProperty = new DatasetPropertyEntity()
            {
                CrossApplyColumn = CrossApplyColumnName,
                CrossApplySupported = true,
                OrderByTimePeriodAsc = @params.OrderByTimeAsc,
                OrderByTimePeriodDesc = @params.OrderByTimeDesc
            };

            if (dataset != null)
            {
                datasetProperty.EntityId = dataset.EntityId;
                datasetProperty.StoreId = dataset.StoreId;
            }

            return datasetProperty;
        }

        public static string GetJsonQuery(MappingSetParams @params)
        {
            var multiQueryList = new List<DisseminationMultiQuery>()
            {
                new()
                {
                    Actions = new[] { ObservationActionEnumType.Deleted.ToString() },
                    Query = @params.DeleteQuery
                },
                new ()
                {
                    Actions = new[] { ObservationActionEnumType.Active.ToString()},
                    Query = @params.ActiveQuery
                },
                new ()
                {
                    Actions = new[] { ObservationActionEnumType.Updated.ToString(),  },
                    Query = @params.ReplaceQuery
                },
            };

            if (!string.IsNullOrEmpty(@params.IncludeHistoryQuery))
            {
                multiQueryList.Add(
                    new()
                    {
                        Actions = new[] { "IncludeHistory", },
                        Query = @params.IncludeHistoryQuery
                    });
            }

            return MultiQueryDatasetEditorEngine.Serialize(multiQueryList);
        }

        private (DatasetEntity, List<DataSetColumnEntity>) SaveDataSet(
            IConnectionEntity connection, 
            Dsd dsd, 
            string datasetName,
            MappingSetParams @params
        )
        {
            var dataSet = new DatasetEntity
            {
                Name = datasetName,
                Description = GetDescription<DatasetEntity>(@params.IsMetadata),
                ParentId = connection.EntityId,
                StoreId = connection.StoreId,
                JSONQuery = GetJsonQuery(@params),
                EditorType = MultiQueryDatasetEditorEngine.EditorType,
                OrderByClause = null,
                DatasetPropertyEntity = GetDatasetProperty(@params)
            };

            try
            {
                var addedDataSet = _persistManager.Add(dataSet);

                // add data columns
                var columnEntities = dsd.Base.Components.Select(component =>
                    new DataSetColumnEntity
                    {
                        ParentId = addedDataSet.EntityId,
                        StoreId = addedDataSet.StoreId,
                        Name = component.Id,
                        Description = GetDescription<DataSetColumnEntity>(@params.IsMetadata)
                    })
                    .ToList();

                // add meta-data columns
                if (@params.IsMetadata && dsd.Msd != null)
                {
                    columnEntities.AddRange(dsd.Msd.MetadataAttributes.Select(metaAttribute =>
                        new DataSetColumnEntity
                        {
                            ParentId = addedDataSet.EntityId,
                            StoreId = addedDataSet.StoreId,
                            Name = metaAttribute.HierarchicalId,
                            Description = GetDescription<DataSetColumnEntity>(true)
                        }));
                }

                _persistManager.AddEntities(columnEntities);

                return (addedDataSet, columnEntities);
            }
            catch (System.Exception e)
            {
                Log.Error(new DotStatException(string.Format(
                    LocalizationRepository.GetLocalisedResource(Localization.ResourceId.ErrorTryingToCreateDataSet),
                    dataSet.Name), e));
            }

            return (null,null);
        }

        private bool UpdateDataSet(
            DatasetEntity dataSet,
            MappingSetParams @params
        )
        {
            var patch = new PatchRequest
            {
                new ("replace", nameof(DatasetEntity.JSONQuery), GetJsonQuery(@params)),
                new ("replace", nameof(DatasetEntity.EditorType), MultiQueryDatasetEditorEngine.EditorType),
                new ("replace", nameof(DatasetEntity.Description), GetDescription<DatasetEntity>(@params.IsMetadata)),
                new ("remove", nameof(DatasetEntity.OrderByClause)),
                new ("remove", nameof(DatasetEntity.Query))
            };

            var dataSetEngine = _persistManager.GetEngine<DatasetEntity>(dataSet.StoreId);
            var datasetPropertyEngine = _persistManager.GetEngine<DatasetPropertyEntity>(dataSet.StoreId);
            try
            {
                dataSetEngine.Update(patch, EntityType.DataSet, dataSet.EntityId);

                if (dataSet.DatasetPropertyEntity == null)
                {
                    dataSet.DatasetPropertyEntity = GetDatasetProperty(@params, dataSet);
                }
                else
                {
                    dataSet.DatasetPropertyEntity.OrderByTimePeriodAsc = @params.OrderByTimeAsc;
                    dataSet.DatasetPropertyEntity.OrderByTimePeriodDesc = @params.OrderByTimeDesc;
                    dataSet.DatasetPropertyEntity.CrossApplyColumn = CrossApplyColumnName;
                    dataSet.DatasetPropertyEntity.CrossApplySupported = true;
                }

                datasetPropertyEngine.Add(dataSet.DatasetPropertyEntity);

                return true;
            }
            catch (System.Exception e)
            {
                Log.Error(new DotStatException(string.Format(
                    LocalizationRepository.GetLocalisedResource(Localization.ResourceId.ErrorTryingToCreateDataSet),
                    dataSet.Name), e));
            }

            return false;
        }
        
        private void DeleteDatasets(string storeId, IList<string> datasetIdsToDelete)
        {
            var dataSetEngine = _persistManager.GetEngine<DatasetEntity>(storeId);

            foreach (var entityId in datasetIdsToDelete)
            {
                try
                {
                    dataSetEngine.Delete(entityId, EntityType.DataSet);
                }
                catch (System.Exception e)
                {
                    Log.Error(new DotStatException(string.Format(
                        LocalizationRepository.GetLocalisedResource(Localization.ResourceId.ErrorTryingToDeleteDataSet), 
                        entityId), e)
                    );
                }
            }
        }
        
        #endregion

        #region MappingSets
        private MappingSetEntity GetMappingSet(DatasetEntity dataSet)
        {
            var entityQuery = new EntityQuery { 
                EntityType = EntityType.MappingSet,
            };

            entityQuery.AddAdditionalCriteria(EntityType.DataSet.ToString(), new Criteria<string>(OperatorType.Exact, dataSet.EntityId));

            return _retrieverManager
                .GetEntities<MappingSetEntity>(dataSet.StoreId, entityQuery, Detail.Full)
                .FirstOrDefault();
        }


        private IEnumerable<MappingSetEntity> GetMappingSetsOfDataflow(string storeId, Dataflow dataFlow)
        {
            var entityQuery = new EntityQuery
            {
                EntityType = EntityType.MappingSet,
                ParentId = new Criteria<string>(OperatorType.Exact, dataFlow.Base.Urn.ToString())
            };

            return _retrieverManager.GetEntities<MappingSetEntity>(storeId, entityQuery, Detail.Full);
        }

        private MappingSetEntity SaveMappingSet(DatasetEntity dataSet, IList<DataSetColumnEntity> dataSetColumnEntities, Dataflow dataflow, DateTime? validFrom, DateTime? validTo, bool isMetadata)
        {
            var mappingSet = new MappingSetEntity()
            {
                Name = $"{MappingSetPrefix}{dataSet.Name}",
                DataSetId = dataSet.EntityId,
                Description = GetDescription<MappingSetEntity>(isMetadata),
                ParentId = dataflow.Base.Urn.ToString(),
                StoreId = dataSet.StoreId,
                ValidFrom = validFrom,
                ValidTo = validTo,
                IsMetadata = isMetadata
            };
            try
            {
                mappingSet = _persistManager.Add(mappingSet);

                SavePreFormattedTime(dataflow, mappingSet, dataSet, dataSetColumnEntities, isMetadata);
                SaveLastUpdateMapping(mappingSet, dataSet, dataSetColumnEntities, isMetadata);
                SaveValidToMapping(mappingSet, dataSet, dataSetColumnEntities, isMetadata);

                return mappingSet;
            }
            catch (System.Exception e)
            {
                Log.Error(new DotStatException(string.Format(
                    LocalizationRepository.GetLocalisedResource(Localization.ResourceId.ErrorTryingToCreateMappingSet),
                    mappingSet.Name), e));
            }

            return null;
        }

        private bool UpdateMappingSet(Dataflow dataflow, MappingSetEntity mappingSet, DatasetEntity dataSet, DateTime? validFrom, DateTime? validTo, bool isMetadata)
        {
            var patch = new PatchRequest
            {
                new ("replace", nameof(MappingSetEntity.ValidFrom), validFrom?.ToString("yyyy-MM-dd HH:mm:ss")),
                new ("replace", nameof(MappingSetEntity.ValidTo), validTo?.ToString("yyyy-MM-dd HH:mm:ss")),
                new ("replace", nameof(MappingSetEntity.Description), GetDescription<MappingSetEntity>(isMetadata))
            };
            
            var mappingSetEngine = _persistManager.GetEngine<MappingSetEntity>(mappingSet.StoreId);
            
            try
            {
                var datasetColumns = GetDatasetColumns(dataSet.StoreId, dataSet.EntityId);
                SavePreFormattedTime(dataflow, mappingSet, dataSet, datasetColumns, isMetadata);
                SaveLastUpdateMapping(mappingSet, dataSet, datasetColumns, isMetadata);
                SaveValidToMapping(mappingSet, dataSet, datasetColumns, isMetadata);

                mappingSetEngine.Update(patch, EntityType.MappingSet, mappingSet.EntityId);
                return true;
            }
            catch (System.Exception e)
            {
                Log.Error(new DotStatException(string.Format(
                    LocalizationRepository.GetLocalisedResource(Localization.ResourceId.ErrorTryingToUpdateMappingSet),
                    mappingSet.Name), e));
            }

            return false;
        }
        
        // returns List of referenced Datasets that needs deleting
        private IList<string> DeleteAllDataflowMappingSets(string storeId, Dataflow dataflow, bool deleteMsdMappingsetsOnly)
        {
            var mappingSetEntities = GetMappingSetsOfDataflow(storeId, dataflow);
            var mappingSetEngine = _persistManager.GetEngine<MappingSetEntity>(storeId);
            var datasetIdsToDelete = new List<string>();

            //Delete automatically created mapping sets of dataflow {parentId}
            foreach (var mappingSet in mappingSetEntities)
            {
                //Skip DSD mappingsets 
                if (deleteMsdMappingsetsOnly && !mappingSet.IsMetadata)
                    continue;

                try
                {
                    mappingSetEngine.Delete(mappingSet.EntityId, EntityType.MappingSet);
                    
                    if (!string.IsNullOrEmpty(mappingSet.DataSetId))
                    {
                        datasetIdsToDelete.Add(mappingSet.DataSetId);
                    }
                }
                catch (System.Exception e)
                {
                    Log.Error(new DotStatException(string.Format(
                        LocalizationRepository.GetLocalisedResource(Localization.ResourceId.ErrorTryingToDeleteMappingSet),
                        mappingSet.Name), e));
                }
            }

            return datasetIdsToDelete;
        }
        
        private bool SaveMappings(string storeId, string mappingSetId, string dataSetId, Dsd dsd, IList<DataSetColumnEntity> dataSetColumnEntities, bool isMetadata)
        {
            dataSetColumnEntities ??= GetDatasetColumns(storeId, dataSetId);
            var componentMappings = new List<ComponentMappingEntity>();
            
            foreach (var component in dsd.Base.Components)
            {
                var componentMapping = new ComponentMappingEntity
                {
                    StoreId = storeId,
                    ParentId = mappingSetId,
                    Name = $"{component.Id}",
                    Type = ComponentMappingType.Normal.AsMappingStoreType(),
                    Component = new Component {ObjectId = component.Id},
                    IsMetadata = false
                };

                var datasetColumn = dataSetColumnEntities.First(entity => entity.Name.Equals(component.Id));
                componentMapping.SetColumns(new[]{datasetColumn});
                componentMappings.Add(componentMapping);
            }

            if (isMetadata && dsd.Msd != null)
            {
                foreach (var metaAttribute in dsd.Msd.MetadataAttributes)
                {
                    var componentMapping = new ComponentMappingEntity
                    {
                        StoreId = storeId,
                        ParentId = mappingSetId,
                        Name = metaAttribute.HierarchicalId,
                        Type = ComponentMappingType.Normal.AsMappingStoreType(),
                        MetadataAttributeSdmxId = metaAttribute.HierarchicalId,
                        IsMetadata = true
                    };

                    var datasetColumn = dataSetColumnEntities.First(entity => entity.Name.Equals(metaAttribute.HierarchicalId));
                    componentMapping.SetColumns(new[] { datasetColumn });
                    componentMappings.Add(componentMapping);
                }
            }

            _persistManager.AddEntities(componentMappings);
            return true;
        }

        private List<DataSetColumnEntity> GetDatasetColumns(string storeId, string dataSetId)
        {
            var entityQuery = new EntityQuery
            {
                EntityType = EntityType.DataSetColumn,
                ParentId = new Criteria<string>(OperatorType.Exact, dataSetId)
            };

            return _retrieverManager
                .GetEntities<DataSetColumnEntity>(storeId, entityQuery, Detail.Full)
                .ToList();
        }

        private void SavePreFormattedTime(Dataflow dataflow, MappingSetEntity mappingSet, DatasetEntity dataSet, IList<DataSetColumnEntity> datasetColumns, bool isMetadata)
        {
            const string PERIOD_START = "PERIOD_START";
            const string PERIOD_END = "PERIOD_END";

            var timeDim = dataflow.Dsd.Base.TimeDimension;

            if (timeDim != null)
            {
                if(!datasetColumns.Any())
                    return;

                var outputColumn = datasetColumns.First(x => x.Name.Equals(timeDim.Id));
                
                var fromColumn = datasetColumns.FirstOrDefault(x => x.Name.Equals(PERIOD_START));
                if (fromColumn is null)
                {
                    fromColumn = _persistManager.Add(new DataSetColumnEntity
                    {
                        ParentId = dataSet.EntityId,
                        StoreId = dataSet.StoreId,
                        Name = PERIOD_START,
                        Description = GetDescription<DataSetColumnEntity>(isMetadata)
                    });

                    datasetColumns.Add(fromColumn);
                }

                var toColumn = datasetColumns.FirstOrDefault(x => x.Name.Equals(PERIOD_END));
                if (toColumn is null)
                {
                    toColumn = _persistManager.Add(new DataSetColumnEntity
                    {
                        ParentId = dataSet.EntityId,
                        StoreId = dataSet.StoreId,
                        Name = PERIOD_END,
                        Description = GetDescription<DataSetColumnEntity>(isMetadata)
                    });

                    datasetColumns.Add(toColumn);
                }

                if(mappingSet.TimePreFormattedEntity is null || mappingSet.TimePreFormattedEntity?.OutputColumn is null)
                {
                    _persistManager.Add(new TimePreFormattedEntity()
                    {
                        EntityId = mappingSet.EntityId,
                        StoreId = mappingSet.StoreId,
                        OutputColumn = outputColumn,
                        FromColumn = fromColumn,
                        ToColumn = toColumn
                    });
                }
            }
        }

        private void SaveLastUpdateMapping(MappingSetEntity mappingSet, DatasetEntity dataSet, IList<DataSetColumnEntity> datasetColumns, bool isMetadata)
        {
            const string LAST_UPDATED = "LAST_UPDATED";

            if (!datasetColumns.Any() || datasetColumns.Any(x => x.Name.Equals(LAST_UPDATED)))
                return;

            var updateColumn = _persistManager.Add(new DataSetColumnEntity
            {
                StoreId = dataSet.StoreId,
                ParentId = dataSet.EntityId,
                Name = LAST_UPDATED,
                Description = GetDescription<DataSetColumnEntity>(isMetadata)
            });

            var componentMapping = new ComponentMappingEntity
            {
                StoreId = dataSet.StoreId,
                ParentId = mappingSet.EntityId,
                Type = ComponentMappingType.LastUpdated.AsMappingStoreType(),
            };

            datasetColumns.Add(updateColumn);
            componentMapping.AddColumn(updateColumn);
            _persistManager.Add(componentMapping);
        }

        private void SaveValidToMapping(MappingSetEntity mappingSet, DatasetEntity dataSet, IList<DataSetColumnEntity> datasetColumns, bool isMetadata)
        {
            const string VALID_TO = "ValidTo";

            if (!datasetColumns.Any() || datasetColumns.Any(x => x.Name.Equals(VALID_TO)))
                return;

            var updateColumn = _persistManager.Add(new DataSetColumnEntity
            {
                StoreId = dataSet.StoreId,
                ParentId = dataSet.EntityId,
                Name = VALID_TO,
                Description = GetDescription<DataSetColumnEntity>(isMetadata)
            });

            var componentMapping = new ComponentMappingEntity
            {
                StoreId = dataSet.StoreId,
                ParentId = mappingSet.EntityId,
                Type = "VALID_TO",
            };

            datasetColumns.Add(updateColumn);
            componentMapping.AddColumn(updateColumn);
            _persistManager.Add(componentMapping);
        }

        #endregion

        #endregion

    }
}